Index: /DCWoRMS/trunk/build/classes/schedframe/resources/computing/profiles/energy/power/ui/ProcessorPowerInterface.java
===================================================================
--- /DCWoRMS/trunk/build/classes/schedframe/resources/computing/profiles/energy/power/ui/ProcessorPowerInterface.java	(revision 477)
+++ /DCWoRMS/trunk/build/classes/schedframe/resources/computing/profiles/energy/power/ui/ProcessorPowerInterface.java	(revision 539)
@@ -1,10 +1,12 @@
 package schedframe.resources.computing.profiles.energy.power.ui;
+
+
+import gridsim.GridSimTags;
+import gridsim.dcworms.DCWormsTags;
 
 import java.util.Map;
 
-import schedframe.events.ResourceEventCommand;
 import schedframe.resources.ResourceStatus;
 import schedframe.resources.computing.ComputingResource;
-import schedframe.resources.computing.Processor;
 import schedframe.resources.computing.profiles.energy.EnergyEvent;
 import schedframe.resources.computing.profiles.energy.EnergyEventType;
@@ -16,5 +18,5 @@
 import schedframe.resources.units.StandardResourceUnitName;
 
-public class ProcessorPowerInterface extends AbstractPowerInterface {
+public class ProcessorPowerInterface extends ComputingResourcePowerInterface {
 
 	protected PState currentPState;
@@ -36,5 +38,4 @@
 		if(powerState != currentPowerState){
 			currentPowerState = powerState;
-			//Processor cpu = (Processor) resource;
 			if(powerState == StandardPowerStateName.OFF){
 				resource.setStatus(ResourceStatus.UNAVAILABLE);
@@ -42,6 +43,5 @@
 				resource.setStatus(ResourceStatus.FREE);
 			}
-			resource.handleEvent(new EnergyEvent(EnergyEventType.POWER_STATE_CHANGED, resource.getName()));
-			//cpu.handleEvent(new EnergyEvent(EnergyEventType.POWER_STATE_CHANGED, cpu.getName()));			
+			resource.handleEvent(new EnergyEvent(EnergyEventType.POWER_STATE_CHANGED, resource.getName()));		
 		}
 
@@ -79,11 +79,11 @@
 
 		if(newPState != currentPState){
-			double factor = newPState.getFrequency()/currentPState.getFrequency();
+			//double factor = newPState.getFrequency()/currentPState.getFrequency();
 			currentPState = newPState;
-			CpuSpeed speed = (CpuSpeed)resource.getResourceCharacteristic().getResourceUnits().get(StandardResourceUnitName.CPUSPEED).get(0);
-			speed.setAmount(Double.valueOf(currentPState.getFrequency()).intValue());
+			//CpuSpeed speed = (CpuSpeed)resource.getResourceCharacteristic().getResourceUnits().get(StandardResourceUnitName.CPUSPEED).get(0);
+			//speed.setAmount(Double.valueOf(currentPState.getFrequency()).intValue());
 			//new ResourceEventCommand(resource).execute(EnergyEventType.FREQUENCY_CHANGED);
 			resource.handleEvent(new EnergyEvent(EnergyEventType.FREQUENCY_CHANGED, resource.getName()));
-			//resource.getScheduler().sendInternal(GridSimTags.SCHEDULE_NOW, GssimTags.UPDATE, resource.getName());
+			//resource.getScheduler().sendInternal(GridSimTags.SCHEDULE_NOW, DCWormsTags.UPDATE, resource.getName());
 			return true;
 		}
Index: /DCWoRMS/trunk/build/classes/schedframe/resources/computing/profiles/energy/power/ui/DataCenterPowerInterface.java
===================================================================
--- /DCWoRMS/trunk/build/classes/schedframe/resources/computing/profiles/energy/power/ui/DataCenterPowerInterface.java	(revision 477)
+++ /DCWoRMS/trunk/build/classes/schedframe/resources/computing/profiles/energy/power/ui/DataCenterPowerInterface.java	(revision 539)
@@ -7,9 +7,6 @@
 import schedframe.resources.computing.profiles.energy.power.StandardPowerStateName;
 
-public class DataCenterPowerInterface extends AbstractPowerInterface{
+public class DataCenterPowerInterface extends ComputingResourcePowerInterface{
 
-
-
-	
 	public DataCenterPowerInterface(ComputingResource resource, PowerProfile pp){
 		super(resource, pp);
Index: /DCWoRMS/trunk/build/classes/schedframe/resources/computing/profiles/energy/power/PowerInterfaceFactory.java
===================================================================
--- /DCWoRMS/trunk/build/classes/schedframe/resources/computing/profiles/energy/power/PowerInterfaceFactory.java	(revision 539)
+++ /DCWoRMS/trunk/build/classes/schedframe/resources/computing/profiles/energy/power/PowerInterfaceFactory.java	(revision 539)
@@ -0,0 +1,51 @@
+package schedframe.resources.computing.profiles.energy.power;
+
+import schedframe.resources.StandardResourceType;
+import schedframe.resources.computing.ComputingResource;
+import schedframe.resources.computing.profiles.energy.power.ui.PowerInterface;
+
+public class PowerInterfaceFactory {
+
+
+
+	//new1
+	/*public static PowerInterface createPowerProfile(ResourceType resourceType, List<PowerState> powerStates, List<PState> pStates, String eepn){
+
+		PowerInterface powerProfile;
+
+		switch(resourceType){
+			case DataCenter: powerProfile = new DataCenterPowerInterfaceNew(eepn, powerStates); break;
+			case ComputingNode: powerProfile = new ComputingNodePowerInterfaceNew(eepn, powerStates); break;
+			case Processor: powerProfile = new CPUPowerInterfaceNew(eepn, powerStates, pStates); break;
+			default:
+				throw new IllegalArgumentException("ResourceType " + resourceType + " is not supported.");
+		}
+
+		return powerProfile;
+	}*/
+	
+	public static PowerInterface createPowerInterface(ComputingResource resource, PowerProfile pp){
+		if(pp == null)
+			return null;
+		PowerInterface powerInterface;
+
+		if(resource.getType().getName().equals(StandardResourceType.DataCenter.getName()))
+			powerInterface = new schedframe.resources.computing.profiles.energy.power.ui.DataCenterPowerInterface(resource, pp);
+		else if (resource.getType().getName().equals(StandardResourceType.ComputingNode.getName()))
+			powerInterface = new schedframe.resources.computing.profiles.energy.power.ui.ComputingNodePowerInterface(resource, pp);
+		else if (resource.getType().getName().equals(StandardResourceType.Processor.getName()))
+			powerInterface = new schedframe.resources.computing.profiles.energy.power.ui.ProcessorPowerInterface(resource, pp);
+		else 
+			powerInterface = new schedframe.resources.computing.profiles.energy.power.ui.ComputingResourcePowerInterface(resource, pp);
+
+		/*switch(resource.getType()){
+			case DataCenter: powerInterface = new test.rewolucja.energy.profile.implementation.alternative2.DataCenterPowerInterfaceNew(resource, pp); break;
+			case ComputingNode: powerInterface = new test.rewolucja.energy.profile.implementation.alternative2.ComputingNodePowerInterfaceNew(resource, pp); break;
+			case Processor: powerInterface = new test.rewolucja.energy.profile.implementation.alternative2.CPUPowerInterfaceNew(resource, pp); break;
+			default:
+				throw new IllegalArgumentException("ResourceType " + resource.getType() + " is not supported.");
+		}*/
+
+		return powerInterface;
+	}
+}
Index: /DCWoRMS/trunk/build/classes/schedframe/resources/computing/profiles/energy/EnergyEventType.java
===================================================================
--- /DCWoRMS/trunk/build/classes/schedframe/resources/computing/profiles/energy/EnergyEventType.java	(revision 477)
+++ /DCWoRMS/trunk/build/classes/schedframe/resources/computing/profiles/energy/EnergyEventType.java	(revision 539)
@@ -15,5 +15,8 @@
 	FREQUENCY_CHANGED(64),
 	VOLTAGE_CHANGED(128),
-	RESOURCE_FAILED(256)
+	
+	AIRFLOW_STATE_CHANGED(256),
+	
+	RESOURCE_FAILED(512)
 	;
 
Index: /DCWoRMS/trunk/build/classes/schedframe/resources/computing/profiles/energy/airthroughput/AirFlowValue.java
===================================================================
--- /DCWoRMS/trunk/build/classes/schedframe/resources/computing/profiles/energy/airthroughput/AirFlowValue.java	(revision 539)
+++ /DCWoRMS/trunk/build/classes/schedframe/resources/computing/profiles/energy/airthroughput/AirFlowValue.java	(revision 539)
@@ -0,0 +1,11 @@
+package schedframe.resources.computing.profiles.energy.airthroughput;
+
+import schedframe.resources.computing.profiles.energy.MeasurementHistory;
+
+public class AirFlowValue extends MeasurementHistory{
+
+	public AirFlowValue(long timestamp, double value){
+		super(timestamp, value);
+	}
+	
+}
Index: /DCWoRMS/trunk/build/classes/schedframe/resources/computing/profiles/energy/airthroughput/AirThroughputProfile.java
===================================================================
--- /DCWoRMS/trunk/build/classes/schedframe/resources/computing/profiles/energy/airthroughput/AirThroughputProfile.java	(revision 477)
+++ /DCWoRMS/trunk/build/classes/schedframe/resources/computing/profiles/energy/airthroughput/AirThroughputProfile.java	(revision 539)
@@ -1,5 +1,8 @@
 package schedframe.resources.computing.profiles.energy.airthroughput;
 
+import java.util.ArrayList;
 import java.util.List;
+
+import org.joda.time.DateTimeUtils;
 
 import schedframe.Parameters;
@@ -8,6 +11,9 @@
 public class AirThroughputProfile {
 	
-	AirThroughputEstimationPlugin airThroughputEstimationPlugin;
+	protected List<AirFlowValue> airFlowHistory;
+	
+	protected AirThroughputEstimationPlugin airThroughputEstimationPlugin;
 	protected List <AirThroughputState> airThroughputStates;
+	protected Parameters parameters;
 
 	public AirThroughputProfile(AirThroughputEstimationPlugin airThroughputEstimationPlugin, List<AirThroughputState> airThroughputStates) {
@@ -15,4 +21,5 @@
 		this.airThroughputEstimationPlugin = airThroughputEstimationPlugin;
 		this.airThroughputStates = airThroughputStates;
+		this.airFlowHistory = new ArrayList<AirFlowValue>();
 	}
 
@@ -21,6 +28,38 @@
 	}
 	
-	public void init(Parameters parameters){
-		
+	public void addToPowerUsageHistory(double airFlow) {
+
+		if (airFlowHistory.size() == 0) {
+			AirFlowValue usage = new AirFlowValue(DateTimeUtils.currentTimeMillis(), airFlow);
+			airFlowHistory.add(usage);
+			return;
+		}
+
+		int lastIdx = airFlowHistory.size() - 1;
+		double lastAirFlow = airFlowHistory.get(lastIdx).getValue();
+		if (lastAirFlow != airFlow) {
+			AirFlowValue usage = airFlowHistory.get(lastIdx);
+			long currentTime = DateTimeUtils.currentTimeMillis();
+			if (usage.getTimestamp() == currentTime) {
+				usage.setValue(airFlow);
+				if(lastIdx > 0 && airFlowHistory.get(lastIdx - 1).getValue() == airFlow)
+					airFlowHistory.remove(usage);
+			} else {
+				usage = new AirFlowValue(DateTimeUtils.currentTimeMillis(), airFlow);
+				airFlowHistory.add(usage);
+			}
+		}
+	}
+
+	public List<AirFlowValue> getAirThroughputHistory() {
+		return airFlowHistory;
+	}
+	
+	public void init(Parameters params){
+		this.parameters = params;
+	}
+
+	public Parameters getParameters() {
+		return parameters;
 	}
 }
Index: /DCWoRMS/trunk/build/classes/schedframe/resources/computing/profiles/energy/airthroughput/ui/AirThroughputInterface.java
===================================================================
--- /DCWoRMS/trunk/build/classes/schedframe/resources/computing/profiles/energy/airthroughput/ui/AirThroughputInterface.java	(revision 539)
+++ /DCWoRMS/trunk/build/classes/schedframe/resources/computing/profiles/energy/airthroughput/ui/AirThroughputInterface.java	(revision 539)
@@ -0,0 +1,21 @@
+package schedframe.resources.computing.profiles.energy.airthroughput.ui;
+
+import java.util.List;
+
+import schedframe.Parameters;
+import schedframe.resources.computing.profiles.energy.airthroughput.AirThroughputState;
+
+public interface AirThroughputInterface {
+	
+	public String getAirThroughputState();
+	
+	public boolean setAirThroughputState(String airThroughputState);
+	
+	public boolean supportAirThroughputState(String powerState);
+	
+	public List<AirThroughputState> getSupportedAirThroughputStates() throws NoSuchFieldException;
+	
+	public double getPowerConsumption(String state) throws NoSuchFieldException;
+	
+	public Parameters getParameters();
+}
Index: /DCWoRMS/trunk/build/classes/schedframe/resources/computing/profiles/energy/airthroughput/ui/DefaultAirThroughputInterface.java
===================================================================
--- /DCWoRMS/trunk/build/classes/schedframe/resources/computing/profiles/energy/airthroughput/ui/DefaultAirThroughputInterface.java	(revision 539)
+++ /DCWoRMS/trunk/build/classes/schedframe/resources/computing/profiles/energy/airthroughput/ui/DefaultAirThroughputInterface.java	(revision 539)
@@ -0,0 +1,74 @@
+package schedframe.resources.computing.profiles.energy.airthroughput.ui;
+
+import java.util.ArrayList;
+import java.util.List;
+
+import schedframe.Parameters;
+import schedframe.resources.computing.ComputingResource;
+import schedframe.resources.computing.profiles.energy.EnergyEvent;
+import schedframe.resources.computing.profiles.energy.EnergyEventType;
+import schedframe.resources.computing.profiles.energy.airthroughput.AirThroughputProfile;
+import schedframe.resources.computing.profiles.energy.airthroughput.AirThroughputState;
+
+public class DefaultAirThroughputInterface implements AirThroughputInterface{
+
+	protected String currentAirThroughputState;
+	protected AirThroughputProfile airThroughputProfile;
+	protected ComputingResource resource;
+	
+	public DefaultAirThroughputInterface(ComputingResource resource, AirThroughputProfile airThroughputProfile){
+		this.resource = resource;
+		this.airThroughputProfile = airThroughputProfile;
+	}
+	
+	public String getAirThroughputState() {
+		return currentAirThroughputState;
+	}
+
+	public boolean setAirThroughputState(String state) {
+		if(supportAirThroughputState(state)){
+			currentAirThroughputState = state;
+			
+			//TO DO - notifications should be called for all resources starting form the lowest layer
+			resource.handleEvent(new EnergyEvent(EnergyEventType.AIRFLOW_STATE_CHANGED, resource.getName()));
+
+			return true;
+		}
+		return false;
+	}
+
+	public boolean supportAirThroughputState(String state) {
+		for(AirThroughputState airFlowState: airThroughputProfile.getAirThroughputStates()){
+			if(airFlowState.getName().equals(state)){
+				return true;
+			}
+		}
+		return false;
+	}
+
+	public List<AirThroughputState> getSupportedAirThroughputStates() throws NoSuchFieldException {
+		List<AirThroughputState> airThroughputStates = new ArrayList<AirThroughputState>();
+		for(AirThroughputState airFlowState: airThroughputProfile.getAirThroughputStates()){
+			airThroughputStates.add(airFlowState);
+		}
+		return airThroughputStates;
+	}
+
+	public double getPowerConsumption(String state) throws NoSuchFieldException {
+		double powerConsumption = 0;
+		if(supportAirThroughputState(state)){
+			for(AirThroughputState airFlowState: airThroughputProfile.getAirThroughputStates()){
+				if(airFlowState.getName().equals(state)){
+					powerConsumption = airFlowState.getPowerUsage();
+					break;
+				}
+			}
+		}
+		return powerConsumption;
+	}
+
+	public Parameters getParameters() {
+		return airThroughputProfile.getParameters();
+	}
+
+}
Index: /DCWoRMS/trunk/build/classes/schedframe/resources/computing/profiles/energy/airthroughput/AirThroughputInterfaceFactory.java
===================================================================
--- /DCWoRMS/trunk/build/classes/schedframe/resources/computing/profiles/energy/airthroughput/AirThroughputInterfaceFactory.java	(revision 539)
+++ /DCWoRMS/trunk/build/classes/schedframe/resources/computing/profiles/energy/airthroughput/AirThroughputInterfaceFactory.java	(revision 539)
@@ -0,0 +1,16 @@
+package schedframe.resources.computing.profiles.energy.airthroughput;
+
+import schedframe.resources.computing.ComputingResource;
+import schedframe.resources.computing.profiles.energy.airthroughput.ui.AirThroughputInterface;
+import schedframe.resources.computing.profiles.energy.airthroughput.ui.DefaultAirThroughputInterface;
+
+public class AirThroughputInterfaceFactory {
+	
+	public static AirThroughputInterface createAirThroughputInterface(ComputingResource resource, AirThroughputProfile atp){
+		if(atp == null)
+			return null;
+		AirThroughputInterface airThroughputInterface = new DefaultAirThroughputInterface(resource, atp);
+
+		return airThroughputInterface;
+	}
+}
Index: /DCWoRMS/trunk/build/classes/schedframe/resources/computing/profiles/energy/EnergyExtension.java
===================================================================
--- /DCWoRMS/trunk/build/classes/schedframe/resources/computing/profiles/energy/EnergyExtension.java	(revision 477)
+++ /DCWoRMS/trunk/build/classes/schedframe/resources/computing/profiles/energy/EnergyExtension.java	(revision 539)
@@ -11,9 +11,11 @@
 import schedframe.resources.computing.extensions.ExtensionException;
 import schedframe.resources.computing.extensions.ExtensionType;
+import schedframe.resources.computing.profiles.energy.airthroughput.AirThroughputProfile;
+import schedframe.resources.computing.profiles.energy.airthroughput.ui.AirThroughputInterface;
 import schedframe.resources.computing.profiles.energy.power.PowerProfile;
 import schedframe.resources.computing.profiles.energy.power.ui.PowerInterface;
 import schedframe.scheduling.manager.tasks.JobRegistryImpl;
 
-public class EnergyExtension implements Extension/*, ResourceVisitor */{
+public class EnergyExtension implements Extension{
 
 	private Log log = LogFactory.getLog(EnergyExtension.class);
@@ -21,5 +23,8 @@
 	protected PowerInterface powerInterface;
 	protected PowerProfile powerProfile;
-
+	
+	protected AirThroughputInterface airFlowInterface;
+	protected AirThroughputProfile airFlowProfile;
+	
   	protected ComputingResource computingResource;
 
@@ -29,10 +34,17 @@
 	}
 
-	@Override
+	public EnergyExtension(PowerInterface powerInterface, PowerProfile powerProfile,
+			AirThroughputInterface airFlowInterface, AirThroughputProfile airFlowProfile) {
+		super();
+		this.powerInterface = powerInterface;
+		this.powerProfile = powerProfile;
+		this.airFlowInterface = airFlowInterface;
+		this.airFlowProfile = airFlowProfile;
+	}
+
 	public boolean supportsEvent(Event event) {
 
 		if(powerProfile == null || powerProfile.getEnergyEstimationPlugin() == null)
 			return false;
-		
 		if(event.getType().getName().equals(EnergyEventType.POWER_STATE_CHANGED.getName()))
 			return true;
@@ -43,10 +55,14 @@
 		else if(event.getType().getName().equals(EnergyEventType.TASK_FINISHED.getName()))
 			return true;
+		
+		if(airFlowProfile == null)
+			return false;	
+		if(event.getType().getName().equals(EnergyEventType.AIRFLOW_STATE_CHANGED.getName()))
+			return true;
+		
 		else return false;
 
 	}
-	
 
-	@Override
 	public void handleEvent(Event event) {
 		EnergyEvent enEvent = (EnergyEvent)event;
@@ -87,15 +103,19 @@
 			//System.out.println(this.resource.getName() + " - ESTIMATED ENERGY:" + power);
 			powerProfile.addToPowerUsageHistory(power);
-
+			break;
+		case AIRFLOW_STATE_CHANGED:
+			System.out.println("=====");
+			double airFlow = powerProfile.getEnergyEstimationPlugin().estimateAirThroughput(enEvent, new JobRegistryImpl(computingResource.getName()), computingResource);
+			airFlowProfile.addToPowerUsageHistory(airFlow);
+			power = powerProfile.getEnergyEstimationPlugin().estimatePowerConsumption(enEvent, new JobRegistryImpl(computingResource.getName()), computingResource);
+			powerProfile.addToPowerUsageHistory(power);
 			break;
 		}
 	}
-	
-	@Override
+
 	public void init(Properties properties) throws ExtensionException {
 		// TODO Auto-generated method stub
 	}
 
-	@Override
 	public ExtensionType getType() {
 		return ExtensionType.ENERGY_EXTENSION;
@@ -118,4 +138,11 @@
 	}
 
+	public AirThroughputInterface getAirThroughputInterface() {
+		return airFlowInterface;
+	}
+
+	public AirThroughputProfile getAirFlowProfile() {
+		return airFlowProfile;
+	}
 
 }
Index: /DCWoRMS/trunk/build/classes/schedframe/resources/computing/profiles/energy/MeasurementHistory.java
===================================================================
--- /DCWoRMS/trunk/build/classes/schedframe/resources/computing/profiles/energy/MeasurementHistory.java	(revision 539)
+++ /DCWoRMS/trunk/build/classes/schedframe/resources/computing/profiles/energy/MeasurementHistory.java	(revision 539)
@@ -0,0 +1,25 @@
+package schedframe.resources.computing.profiles.energy;
+
+public class MeasurementHistory {
+	
+	protected long timestamp;
+	protected double value;
+
+	public MeasurementHistory (long timestamp, double value){
+		this.timestamp = timestamp;
+		this.value = value;
+	}
+	
+	public long getTimestamp() {
+		return timestamp;
+	}
+
+	public double getValue() {
+		return value;
+	}
+	
+	public void setValue(double value) {
+		this.value = value;
+	}
+	
+}
Index: /DCWoRMS/trunk/build/classes/schedframe/ResourceController.java
===================================================================
--- /DCWoRMS/trunk/build/classes/schedframe/ResourceController.java	(revision 477)
+++ /DCWoRMS/trunk/build/classes/schedframe/ResourceController.java	(revision 539)
@@ -19,4 +19,5 @@
 	protected static List<ComputingResource> computingResources;
 	protected Deque<Initializable> toInit;
+	protected Set<String> compResLayers;
 	
 	public  ResourceController(Scheduler logicalStructure, List<ComputingResource> compResources){
@@ -144,3 +145,12 @@
 	}
 
+	public Set<String> getComputingResourceLayers() {
+		return compResLayers;
+	}
+
+	public void setCompResLayers(Set<String> compResLayers) {
+		this.compResLayers = compResLayers;
+	}
+
+
 }
Index: /DCWoRMS/trunk/build/classes/schedframe/ExecutablesList.java
===================================================================
--- /DCWoRMS/trunk/build/classes/schedframe/ExecutablesList.java	(revision 539)
+++ /DCWoRMS/trunk/build/classes/schedframe/ExecutablesList.java	(revision 539)
@@ -0,0 +1,155 @@
+package schedframe;
+
+
+import java.util.ArrayList;
+import java.util.Collection;
+import java.util.Collections;
+import java.util.Iterator;
+import java.util.List;
+import java.util.ListIterator;
+
+import dcworms.schedframe.scheduling.ExecTask;
+import dcworms.schedframe.scheduling.Executable;
+
+public class ExecutablesList implements List<ExecTask> {
+
+	private List<ExecTask> executables;
+	
+	public ExecutablesList (){
+		executables = Collections.synchronizedList(new ArrayList<ExecTask>());
+	}
+
+	public List<Executable> getJobExecutables(String jobId){
+		List<Executable> list = new ArrayList<Executable>();
+		synchronized (executables)  {
+			for(int i = 0; i < executables.size(); i++){
+				Executable exec = (Executable)executables.get(i);
+				
+				if(exec.getJobId().equals(jobId))
+					list.add(exec);
+			}
+		}
+		return list;
+	}
+	
+	public List<Executable> getTaskExecutables(String jobId, String taskId){
+		
+		List<Executable> list = new ArrayList<Executable>();
+		synchronized (executables)  {
+			for(int i = 0; i < executables.size(); i++){
+				Executable exec = (Executable)executables.get(i);
+				
+				if(exec.getJobId().equals(jobId) && exec.getId().equals(taskId))
+					list.add(exec);
+			}
+		}
+		return list;
+	}
+	
+	public Executable getTaskExecutable(Integer executableId){
+		synchronized (executables)  {
+			for (ExecTask task : executables) {
+				Executable exec = (Executable)task;
+				if (exec.getUniqueId() == executableId) {
+					return exec;
+				}
+			}
+		}
+		return null;
+	}
+	
+	
+	public boolean add(ExecTask arg0) {
+		return executables.add(arg0);
+	}
+
+	public void add(int arg0, ExecTask arg1) {
+		executables.add(arg0, arg1);
+	}
+
+	public boolean addAll(Collection<? extends ExecTask> arg0) {
+		return executables.addAll(arg0);
+	}
+
+	public boolean addAll(int arg0, Collection<? extends ExecTask> arg1) {
+		return executables.addAll(arg0, arg1);
+	}
+
+	public void clear() {
+		executables.clear();
+	}
+
+	public boolean contains(Object arg0) {
+		return executables.contains(arg0);
+	}
+
+	public boolean containsAll(Collection<?> arg0) {
+		return executables.containsAll(arg0);
+	}
+
+	public ExecTask get(int arg0) {
+		return executables.get(arg0);
+	}
+
+	public int indexOf(Object arg0) {
+		return indexOf(arg0);
+	}
+
+	public boolean isEmpty() {
+		return executables.isEmpty();
+	}
+
+	public Iterator<ExecTask> iterator() {
+		return executables.iterator();
+	}
+
+	public int lastIndexOf(Object arg0) {
+		return executables.lastIndexOf(arg0);
+	}
+
+	public ListIterator<ExecTask> listIterator() {
+		return executables.listIterator();
+	}
+
+	public ListIterator<ExecTask> listIterator(int arg0) {
+		return executables.listIterator(arg0);
+	}
+
+	public boolean remove(Object arg0) {
+		return executables.remove(arg0);
+	}
+
+	public ExecTask remove(int arg0) {
+		return executables.remove(arg0);
+	}
+
+	public boolean removeAll(Collection<?> arg0) {
+		return executables.removeAll(arg0);
+	}
+
+	public boolean retainAll(Collection<?> arg0) {
+		return executables.retainAll(arg0);
+	}
+
+	public ExecTask set(int arg0, ExecTask arg1) {
+		return executables.set(arg0, arg1);
+	}
+
+	public int size() {
+		return executables.size();
+	}
+
+	public List<ExecTask> subList(int arg0, int arg1) {
+		return executables.subList(arg0, arg1);
+	}
+
+	public Object[] toArray() {
+		return executables.toArray();
+	}
+
+	public <T> T[] toArray(T[] arg0) {
+		return executables.toArray(arg0);
+	}
+	
+}
+
Index: /DCWoRMS/trunk/build/classes/schedframe/scheduling/TaskList.java
===================================================================
--- /DCWoRMS/trunk/build/classes/schedframe/scheduling/TaskList.java	(revision 539)
+++ /DCWoRMS/trunk/build/classes/schedframe/scheduling/TaskList.java	(revision 539)
@@ -0,0 +1,10 @@
+package schedframe.scheduling;
+
+import java.util.List;
+
+import schedframe.scheduling.tasks.TaskInterface;
+
+
+public interface TaskList extends List<TaskInterface<?>>{
+
+}
Index: /DCWoRMS/trunk/build/classes/schedframe/scheduling/queue/TaskQueue.java
===================================================================
--- /DCWoRMS/trunk/build/classes/schedframe/scheduling/queue/TaskQueue.java	(revision 477)
+++ /DCWoRMS/trunk/build/classes/schedframe/scheduling/queue/TaskQueue.java	(revision 539)
@@ -1,13 +1,13 @@
 package schedframe.scheduling.queue;
 
-import gridsim.Gridlet;
-import gssim.schedframe.scheduling.queues.AbstractStatsSupportingQueue;
+import gridsim.dcworms.DCWormsTags;
 
 import org.joda.time.DateTime;
 
-import schedframe.scheduling.tasks.WorkloadUnit;
+import dcworms.schedframe.scheduling.queues.AbstractStatsSupportingQueue;
 
-public class TaskQueue extends AbstractStatsSupportingQueue<WorkloadUnit<?>> implements Queue<WorkloadUnit<?>>{
+import schedframe.scheduling.tasks.TaskInterface;
 
+public class TaskQueue extends AbstractStatsSupportingQueue<TaskInterface<?>> implements Queue<TaskInterface<?>>{
 
 	private static final long serialVersionUID = 6576299222910508209L;
@@ -17,35 +17,30 @@
 	protected boolean supportReservation;
 	
-	
 	public TaskQueue (boolean supportReservation){
-		name = "Queue";
-		priority = 0;
+		this.name = "Queue";
+		this.priority = 0;
 		this.supportReservation = supportReservation;
-
 	}
 	
-	public boolean add(WorkloadUnit<?> wu){
+	public boolean add(TaskInterface<?> task){
 		try {
-			wu.setStatus(Gridlet.QUEUED);
+			task.setStatus(DCWormsTags.QUEUED);
 		} catch(Exception e){
 			throw new RuntimeException(e);
 		}
-		//updateStats();
-		return super.add(wu);
+		return super.add(task);
 	}
 	
-	public void add(int pos, WorkloadUnit<?> wu){
+	public void add(int pos, TaskInterface<?> task){
 		try {
-			wu.setStatus(Gridlet.QUEUED);
+			task.setStatus(DCWormsTags.QUEUED);
 		} catch(Exception e){
 			throw new RuntimeException(e);
 		}
-		//updateStats();
-		 super.add(pos, wu);
+		 super.add(pos, task);
 	}
 	
 	public DateTime getArrivalTime(int pos) throws IndexOutOfBoundsException {
-		//return get(pos).getSubmissionTimeToBroker();
-		return null;
+		return get(pos).getSubmissionTimeToBroker();
 	}
 
@@ -69,35 +64,3 @@
 		return supportReservation;
 	}
-	
-	
-	/*public boolean contains (WorkloadUnitInterface<?> wu) {
-		for(int i = 0; i< size();i++){
-			try {
-				if(get(i).getId().equals(wu.getId()))
-					return true;
-			} catch (NoSuchFieldException e) {
-				return false;
-			}
-		}
-		return false;
-	}
-	
-	public boolean remove (WorkloadUnitInterface<?> wu) {
-		boolean found = false;
-		int index = 0;
-		for(int i = 0; i< size() && !found;i++){
-			try {
-				if(get(i).getId().equals(wu.getId()))
-				{
-					found = true;
-					index = i;
-				}
-				
-			} catch (NoSuchFieldException e) {
-				return false;
-			}
-		}
-		remove(index);
-		return true;
-	}*/
 }
Index: /DCWoRMS/trunk/build/classes/schedframe/scheduling/tasks/Job.java
===================================================================
--- /DCWoRMS/trunk/build/classes/schedframe/scheduling/tasks/Job.java	(revision 477)
+++ /DCWoRMS/trunk/build/classes/schedframe/scheduling/tasks/Job.java	(revision 539)
@@ -18,5 +18,4 @@
 import schedframe.scheduling.WorkloadUnitHandler;
 import schedframe.scheduling.manager.tasks.JobRegistryImpl;
-import schedframe.scheduling.policy.AbstractManagementSystem;
 
 
@@ -179,5 +178,5 @@
 	}
 	
-	public int getUserID(){
+	public int getUserId(){
 		return this.senderId;
 	}
@@ -204,6 +203,6 @@
 		
 		List<Task> readyTasks = new ArrayList<Task>();
-
 		int size = tasks.size();
+		
 		for(int i = 0; i < size; i++){
 			int parCnt;
@@ -216,12 +215,9 @@
 			} catch(Exception e){
 				parCnt = 0;
-				//e.printStackTrace();
-			}
-			if(parCnt == 0)
-			{
+			}
+			if(parCnt == 0) {
 				readyTasks.add(task);
 			}
-			else
-			{
+			else {
 				for(int j = 0; j < parCnt; j++){
 					ParentType par = task.getDescription().getWorkflow().getParent(j);
Index: /DCWoRMS/trunk/build/classes/schedframe/scheduling/tasks/WorkloadUnit.java
===================================================================
--- /DCWoRMS/trunk/build/classes/schedframe/scheduling/tasks/WorkloadUnit.java	(revision 477)
+++ /DCWoRMS/trunk/build/classes/schedframe/scheduling/tasks/WorkloadUnit.java	(revision 539)
@@ -1,52 +1,19 @@
 package schedframe.scheduling.tasks;
 
-import java.util.List;
-
-import schedframe.DescriptionContainer;
 import schedframe.scheduling.WorkloadUnitHandler;
 import schedframe.scheduling.manager.tasks.JobRegistryImpl;
-import schedframe.scheduling.policy.AbstractManagementSystem;
 
-public interface WorkloadUnit<T> extends DescriptionContainer<T> {
+public interface WorkloadUnit {
 
-	/**
-	 * 
-	 * @return job identifier
-	 * @throws NoSuchFieldException if there is no tasks for this job, and job id can not be obtained
-	 */
-	public abstract String getId() throws NoSuchFieldException;
+	public String getId();
 	
-	/**
-	 * 
-	 * @return list of tasks which belongs to this job
-	 */
-	public abstract List<? extends TaskInterface<?>> getTask();
+	public int getUserId();
 	
-	/**
-	 * 
-	 * @param taskId
-	 * @return task with specified taskId
-	 * @throws NoSuchFieldException if task with taskId does not exist in this job
-	 */
-	public abstract TaskInterface<?> getTask(String taskId) throws NoSuchFieldException;
-	
-	/**
-	 * 
-	 * @return number of tasks in this job 
-	 */
-	public abstract int getTaskCount();
-	
-	/**
-	 * 
-	 * @return constant which represents current status of this job
-	 */
 	public int getStatus();
 	
 	public void setStatus(int status) throws Exception;
-	
+
 	public boolean isFinished();
-	
-	public int getUserID();
-	
+
 	public boolean isRegistered();
 
